<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>
    <div id='app'>
        <div>
            <input type="text" name="name" id="name" v-model="newName">
            <button v-if="mode" @click='addUser'> add </button>
            <button v-else="mode" @click='update'> Update</button>
        </div>
        <div>
            <ul v-for="user in users" :key="user.name">
                <li>
                    {{user.name}}
                    <button @click='edit(user)'> Edit</button> 
                    ||
                    <button @click='deleteUser(user.name)'> Delete</button>
                </li>
            </ul>
        </div>

    </div>
    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script>
    var vm = new Vue({
        el:'#app',
        data:{
            newName:'',
            mode:true,
            indexTaken : 0,
            users:[
            {
                'name' : 'Muhammad Iqbal Mubarok',
            },
            {
                'name' : 'Ruby Purwanti',
            },
            {
                'name' : 'Faqih Muhammad',
            },
            ]
        },
        methods: {
            addUser(){
                this.users.push({
                    'name' : this.newName
                })
                // clears the form
                this.newName = ''
            },
            deleteUser(username){
                if (confirm('Anda Yakin?')){
                    this.users = this.users.filter(
                    (user) => user.name != username
                    )
                }
                this.newName = ''
            },
            edit(user){
                this.mode = false
                this.newName = user.name
                this.indexTaken = this.users.indexOf(user)
            },
            update(){
                this.users[this.indexTaken].name = this.newName
                this.mode = true
                this.newName = ''
            }
        },

    })
    </script>
</body>
</html>